<template>
    <el-row :gutter="20">
        <el-col :span="8">
            <el-form label-width="68px">
                <el-form-item label="批次">
                    <el-select v-model="batchId" clearable style="width: 227px">
                        <el-option v-for="b in batchList" :label="b.name" :value="b.batchId"/>
                    </el-select>
                </el-form-item>
                <el-form-item label="考生类型">
                    <el-select v-model="examType" clearable style="width: 227px">
                        <el-option v-for="e in examTypes" :label="e.dictLabel" :value="e.dictValue"/>
                    </el-select>
                </el-form-item>
                <el-form-item label="科目">
                    <el-select v-model="subjectId" clearable style="width: 227px">
                        <el-option-group v-for="g in groupedSubjects" :label="g.label">
                            <el-option v-for="s in g.items" :label="s.subjectName" :value="s.subjectId"/>
                        </el-option-group>
                    </el-select>
                </el-form-item>
            </el-form>
        </el-col>
        <el-col :span="16">
            <class-statistic-table/>
        </el-col>
    </el-row>
    <el-divider/>
    <el-row v-if="!hasBuiltPaper" :gutter="20">
        <el-col :span="6">
            <knowledge-tree/>
        </el-col>
        <el-col :span="18">
            <question-hand @submit="handleSubmit"/>
        </el-col>
    </el-row>
    <built-paper-list ref="built" @send="handleSubmit" />
</template>

<script setup name="PaperFullHand">
import {ElMessage} from "element-plus";
import router from "@/router/index.js";
import consts from "@/utils/consts.js";
import {useProvidePaperClassStatisticCondition} from "@/views/dz/papers/hooks/usePaperClassStatisticCondition.js";
import {useProvidePaperKnowledgeCondition} from "@/views/dz/papers/hooks/usePaperKnowledgeCondition.js";
import {useProvidePaperFullCondition} from "@/views/dz/papers/hooks/usePaperFullCondition.js";
import {usePaperStorage} from "@/views/dz/papers/hooks/usePaperStorage.js";
import ClassStatisticTable from "@/views/dz/papers/components/plugs/class-statistic-table.vue";
import KnowledgeTree from "@/views/dz/papers/components/plugs/knowledge-tree.vue";
import QuestionHand from "@/views/dz/papers/components/plugs/question-hand.vue";
import BuiltPaperList from "@/views/dz/papers/components/plugs/built-paper-list.vue";

const type = consts.enums.buildType.FullHand
const {
    batchId,
    batchList,
    examType,
    examTypes,
    subjectId,
    groupedSubjects,
    conditionArgs,
    onConditionReady
} = useProvidePaperFullCondition(type)
const {selectedClasses, classList, loadClassStatistic} = useProvidePaperClassStatisticCondition()
const {knowledgeNode, knowledgeCheckNodes, loadKnowledge} = useProvidePaperKnowledgeCondition()
const built = ref(null)
const hasBuiltPaper = computed(() => built.value?.hasPaper)

const handleSubmit = async (questions) => {
    // validation
    if (!batchId.value) return ElMessage.error('请选择批次')
    if (!examType.value) return ElMessage.error('请选择考生类型')
    if (!subjectId.value) return ElMessage.error('请选择科目')
    const classIds = selectedClasses.value.map(c => c.classId)
    if (!classIds.length) return ElMessage.error('请选择班级')
    if (!questions.length) return ElMessage.error('请将试题加入试题篮')

    const paper = {
        buildType: type,
        batchId: toValue(batchId),
        examType: toValue(examType),
        subjectId: toValue(subjectId),
        classIds,
        questions
    }
    usePaperStorage(paper)
    await router.push({name: 'PaperDetail'})
}

let statArg = null
const _loadClassStatistic = async () => {
    selectedClasses.value = []
    classList.value = []

    await loadClassStatistic(statArg)
}

onConditionReady(async (payload) => {
    statArg = payload
    knowledgeNode.value = null
    knowledgeCheckNodes.value = []

    await loadKnowledge(payload)
    await _loadClassStatistic()
    await built.value.loadBuiltPaper(payload)
})

watch(conditionArgs, () => built.value.reset())
</script>

<style scoped>

</style>